﻿Type=Activity
Version=1.92
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim NumberListPanelTop As Int		: NumberListPanelTop = 40dip	'just below the 'Your Tickets' label
	Dim NumberOfColumns As Int			: NumberOfColumns = 6
	Dim RowHeight As Int						: RowHeight = 30dip
	Dim RowLineWidth As Int					: RowLineWidth = 1dip
	Dim RowHeight_1 As Int					: RowHeight_1 = RowHeight - RowLineWidth
	Dim ColLineWidth As Int					: ColLineWidth = 1dip
	Dim ColumnWidth(NumberOfColumns) As Int
	Dim ColumnWidth_1(NumberOfColumns) As Int
	Dim TotalColumnWidth(NumberOfColumns + 1) As Int
	Dim SelectedRow As Int					: SelectedRow = -1
	Dim SelectedTicket(NumberOfColumns) As Int
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim CellColor As Int	
	Dim Label1 As Label
	Dim scvListBox1 As ScrollView
	Dim pnlSelectedTicket As Panel
	Dim ButtonUp As GradientDrawable
	Dim ButtonUpClr(2) As Int
	Dim ButtonPressed As GradientDrawable
	Dim ButtonPressedClr(2) As Int
	Dim btnAddTicket As Button
	Dim btnChangeTicket As Button
	Dim btnRemoveTicket As Button
	Dim btnRemoveAll As Button
	Dim TicketListRow() As String
	Dim SelectedRowColor As Int			: SelectedRowColor=Colors.Red
  Dim AdView1 As TapForTap
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'the next 2 lines are for TapForTap which means the TapForTapWrapper library must be included
  AdView1.Initialize("71aca060-beb8-012f-d56e-40400a3f6b7e") 'AppId from developer console
	Activity.AddView(AdView1, 0dip, 100%y - 50dip, 320dip, 50dip)
	
	ButtonUpClr(0) = Colors.RGB(150,150,150)
	ButtonUpClr(1) = Colors.Blue
	ButtonUp.Initialize("TOP_BOTTOM",ButtonUpClr)
	ButtonUp.CornerRadius = 5dip
	ButtonPressedClr(0) = Colors.RGB(150,150,150)
	ButtonPressedClr(1) = Colors.Blue
	ButtonPressed.Initialize("BOTTOM_TOP",ButtonPressedClr)
	ButtonPressed.CornerRadius = 5dip
	CreateScreen
	AddMenus
End Sub

Sub Activity_Resume
	'lod a new TapForTap ad
  AdView1.LoadAds
	
	CellColor = Colors.RGB(100,100,200)
	'first clear the scroll panel
	ClearAll
	'then populate the scroll panel
	Log("EditTickets.Resume Main.TicketList.Size = " & Main.TicketList.Size)
	For x = 0 To Main.TicketList.Size - 1
		TicketListRow = Main.TicketList.Get(x)
		For y = 0 To 5
			Dim l As Label
			l.Initialize("Cell")
			l.Text = TicketListRow(y)
			l.Gravity = Main.Alignment
			l.TextSize = Main.FontSize
			l.TextColor = Main.FontColor
			l.Color = CellColor
			Dim rc As RowCol
			rc.Initialize
			rc.Col = y
			rc.Row = x
			l.Tag = rc
			Log("x = " & x & ", y = " & y & ",Tag = " & l.Tag & ", Text = " & l.Text)
			scvListBox1.Panel.AddView(l, TotalColumnWidth(y), (RowHeight * x), ColumnWidth_1(y), RowHeight_1)					
		Next	'y
	Next	'x
	scvListBox1.Panel.Height = (Main.TicketList.Size * RowHeight)
	'if no tickets have been entered yet (or they've all been deleted) 
	'only make the 'Add Ticket' button visible & centre it
	If Main.TicketList.Size = 0 Then
		btnAddTicket.Left = 50%x - (60dip * Main.scale)
		btnChangeTicket.Visible = False
		btnRemoveTicket.Visible = False
		btnRemoveAll.Visible = False
	Else
		If 100%x < 800 Then
			btnAddTicket.Left = 30dip
		Else
			btnAddTicket.Left = 250dip
		End If
		btnChangeTicket.Visible = True
		btnRemoveTicket.Visible = True
		btnRemoveAll.Visible = True
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	'save the TicketList to the csv file
	If Main.TicketList.Size = 0 Then
		File.WriteString(Main.FolderName, Main.csvFileName, "")
	Else
		Main.StringUtils1.SaveCSV(Main.FolderName, Main.csvFileName, ",",Main.TicketList)
	End If
End Sub
Sub CreateScreen
	Label1.Initialize("Label1")
	Label1.Text = "Your Tickets"
	Label1.Gravity = Gravity.CENTER
	Activity.AddView(Label1, 50%x - (70dip * Main.scale), 0, 140dip * Main.scale, 40dip * Main.scale)
	scvListBox1.Initialize(0)	' initialize the ScrollView
	scvListBox1.Panel.Color = Main.LineColor
	If 100%y < 300 Then
		Activity.AddView(scvListBox1,50%x - (120dip * Main.scale),NumberListPanelTop,240dip * Main.scale,RowHeight * 4)
	Else
		Activity.AddView(scvListBox1,50%x - (120dip * Main.scale),NumberListPanelTop,240dip * Main.scale,RowHeight * 6)
	End If
	'initialise these values in case the program is reloaded with the old values still in memory
	SelectedRow = -1

	For i = 0 To 5
		ColumnWidth(i) = 40dip * Main.scale
	Next
	
	' initialze the internal column width and left coordinates
	TotalColumnWidth(0) = ColLineWidth
	For i = 0 To NumberOfColumns - 1
		ColumnWidth_1(i) = ColumnWidth(i) - ColLineWidth
		TotalColumnWidth(i + 1) = TotalColumnWidth(i) + ColumnWidth(i)
	Next
	'create buttons for add ticket, remove ticket, change ticket
	Dim ButtonWidth As Int
	Dim ButtonHeight As Int
	Dim LeftButtonLeft As Int
	Dim RightButtonLeft As Int
	ButtonWidth = 120dip
	ButtonHeight = 48dip
	If 100%x < 800 Then
		LeftButtonLeft = 30dip
		RightButtonLeft = 170dip
	Else
		LeftButtonLeft = 250dip
		RightButtonLeft = 430dip
	End If
	btnAddTicket.Initialize("btnAddTicket")
	btnAddTicket.Text = "Add Ticket"
	btnAddTicket.Gravity = Gravity.CENTER
	btnAddTicket.Background = ButtonUp
	btnAddTicket.TextColor = Colors.White
'	Activity.AddView(btnAddTicket, 50%x - (60dip * Main.scale), scvListBox1.Top + scvListBox1.Height + (10dip * Main.scale), ButtonWidth, ButtonHeight)
	Activity.AddView(btnAddTicket, LeftButtonLeft, scvListBox1.Top + scvListBox1.Height + (20dip * Main.scale), ButtonWidth, ButtonHeight)

	btnChangeTicket.Initialize("btnChangeTicket")
	btnChangeTicket.Text = "Change Ticket"
	btnChangeTicket.Gravity = Gravity.CENTER
	btnChangeTicket.Background = ButtonUp
	btnChangeTicket.TextColor = Colors.White
	Activity.AddView(btnChangeTicket, RightButtonLeft, btnAddTicket.Top, ButtonWidth, ButtonHeight)

	btnRemoveTicket.Initialize("btnRemoveTicket")
	btnRemoveTicket.Text = "Remove Ticket"
	btnRemoveTicket.Gravity = Gravity.CENTER
	btnRemoveTicket.Background = ButtonUp
	btnRemoveTicket.TextColor = Colors.White
	Activity.AddView(btnRemoveTicket, LeftButtonLeft, btnAddTicket.Top + btnAddTicket.Height + (20dip * Main.scale), ButtonWidth, ButtonHeight)

	btnRemoveAll.Initialize("btnRemoveAll")
	btnRemoveAll.Text = "Remove All"
	btnRemoveAll.Gravity = Gravity.CENTER
	btnRemoveAll.Background = ButtonUp
	btnRemoveAll.TextColor = Colors.White
	Activity.AddView(btnRemoveAll, RightButtonLeft, btnRemoveTicket.Top, ButtonWidth, ButtonHeight)
	Log("Bottom of the Remove All button is " & (btnRemoveAll.Top + btnRemoveAll.Height))
End Sub
Sub AddMenus
	Activity.AddMenuItem("Help", "Menu")
End Sub

Sub Menu_Click
  Dim txt As String
  txt = Sender
  Select txt
  	Case "Help"
			Msgbox("To add a ticket to the list, click Add Ticket." & CRLF & _
				"To remove a ticket from the List, Select it and click Remove Ticket." & CRLF & _
				"To change a ticket, Select it and click Change Ticket.","Lotto Checker Help")
  End Select
End Sub
Sub ClearAll
	'Clears the table
	For i = scvListBox1.Panel.NumberOfViews -1 To 0 Step -1
		scvListBox1.Panel.RemoveViewAt(i)
	Next
	scvListBox1.Panel.Height = 0
	SelectedRow = -1
End Sub
Sub SetCell(Row As Int, Col As Int, Value As String)
	'Sets the value of the given cell
	GetLabelView(Row, Col).Text = Value
End Sub

Sub GetCell(Row As Int, Col As Int) As String
	'Gets the value of the given cell
	Return GetLabelView(Row, Col).Text
End Sub

Sub GetLabelView(Row As Int, Col As Int) As Label
	Log("Number of cells in scvListBox1 = " & scvListBox1.Panel.NumberOfViews)
	'the following display of cells in Main.TicketList does NOT include
	'the Match Count cells on the End of each Row. 
	'So the number should match that in the display of the number of cells in scvListBox1
	Log("Number of cells in Main.TicketList = " & (Main.TicketList.Size * NumberOfColumns))
	'Returns the label in the specific cell
	Dim l As Label
	l = scvListBox1.Panel.GetView(Row * NumberOfColumns + Col)
	Return l
End Sub
Sub SetLabelView(Row As Int, Col As Int, Colour As Int)
	'Sets the colour of the label in the specific cell
	scvListBox1.Panel.GetView(Row * NumberOfColumns + Col).Color = Colour
End Sub
Sub Cell_Click
	Log("Cell_Click entered")
	Dim rc As RowCol
	Dim l As Label
	l = Sender
	rc = l.Tag
	Log("RowCol = " & rc)
	SelectRow(rc)
End Sub
Sub SelectRow(rc As RowCol)
	Dim col As Int
	Dim lblOneTicketNumber As Label
	Log("SelectedRow was " & SelectedRow)
	'Removes the color of previously selected row
	If SelectedRow > -1 Then
		For col = 0 To NumberOfColumns - 1
			SetLabelView(SelectedRow, col, CellColor)
		Next
	End If

	SelectedRow = rc.Row
	Log("SelectRow entered - Row = " & SelectedRow)
	'Sets the color of the selected row & moves each number from the ticket to the global variable SelectedTicket
	'so it can be picked up by the Keyboard routine if btnChangeTicket is clicked
	For col = 0 To NumberOfColumns - 1
		lblOneTicketNumber = GetLabelView(rc.Row, col)
		SelectedTicket(col) = lblOneTicketNumber.Text
		Log("SelectedTicket row = " & SelectedRow & ", col = " & col & ", Text = " & lblOneTicketNumber.Text)
		SetLabelView(rc.Row, col, SelectedRowColor) 
	Next
	scvListBox1.Invalidate
End Sub

Sub btnRemoveTicket_Click
	Dim i As Int
	Dim txt As String
	Dim rc As RowCol
	txt = ""
	If SelectedRow>=0 Then
		'remove the ticket from TicketList
		Main.TicketList.RemoveAt(SelectedRow)
		'shuffle up the tickets
		For i=SelectedRow To Main.TicketList.Size - 1
			For y = 0 To 5
				SetCell(i,y,GetCell(i+1,y)) 
			Next
		Next
		'remove the last ticket cell by cell
		For y = 0 To 5
			scvListBox1.Panel.RemoveViewAt((Main.TicketList.Size) * NumberOfColumns)
		Next
		'resize the panel
		scvListBox1.Panel.Height = (Main.TicketList.Size * RowHeight)

		If SelectedRow=Main.TicketList.Size Then
			SelectedRow=SelectedRow-1
		End If

		If Main.TicketList.Size > 0 Then
			rc.Initialize
			rc.Row = SelectedRow
			SelectRow(rc)
		Else
			btnAddTicket.Left = 50%x - (60dip * Main.scale)
			btnChangeTicket.Visible=False
			btnRemoveTicket.Visible=False
			btnRemoveAll.Visible=False
		End If
		Activity.Invalidate
	Else
		Msgbox("Select a ticket then press 'Remove Ticket'","Warning")
	End If

End Sub
Sub btnRemoveTicket_Down
	btnRemoveTicket.Background = ButtonPressed
End Sub
Sub btnRemoveTicket_Up
	btnRemoveTicket.Background = ButtonUp
End Sub
Sub btnRemoveAll_Click
	Dim txt As String
	txt="Do you really want to delete all?"&CRLF
	If Msgbox2(txt,"ATTENTION","Yes","Cancel","",Null) = DialogResponse.POSITIVE Then
		'Clears the table
		For i = scvListBox1.Panel.NumberOfViews -1 To 0 Step -1
			scvListBox1.Panel.RemoveViewAt(i)
		Next
		Main.TicketList.Clear
		SelectedRow = -1
		btnAddTicket.Left = 50%x - (60dip * Main.scale)
		btnChangeTicket.Visible=False
		btnRemoveTicket.Visible=False
		btnRemoveAll.Visible=False
	End If
End Sub
Sub btnRemoveAll_Down
	btnRemoveAll.Background = ButtonPressed
End Sub
Sub btnRemoveAll_Up
	btnRemoveAll.Background = ButtonUp
End Sub

Sub btnChangeTicket_Click
	If SelectedRow = -1 Then
		Msgbox("Select a ticket then press 'Change Ticket'","Warning")
	Else
		Main.AddIndicator = False
		StartActivity(KeyBoard)
	End If
End Sub
Sub btnChangeTicket_Down
	btnChangeTicket.Background = ButtonPressed
End Sub
Sub btnChangeTicket_Up
	btnChangeTicket.Background = ButtonUp
End Sub
Sub btnAddTicket_Click
	'initialise the 6 numbers that make up the SelectedTicket so that the KeyBoard routine knows it is 
	'adding a ticket and not editing an existing ticket
	For x = 0 To 5
		SelectedTicket(x) = 0
	Next
	Main.AddIndicator = True
	StartActivity(KeyBoard)
End Sub
Sub btnAddTicket_Down
	btnAddTicket.Background = ButtonPressed
End Sub
Sub btnAddTicket_Up
	btnAddTicket.Background = ButtonUp
End Sub
Sub Activity_KeyPress (KeyCode As Int) As Boolean
	Log("Activity_KeyPress entered - KeyCode = " & KeyCode)
	'if the back key is pressed on this screen we want to return to the first screen,
	'not the last one seen 
	Select KeyCode
		Case KeyCodes.KEYCODE_BACK
			Activity.Finish
			StartActivity(Main)
			Return False
		Case KeyCodes.KEYCODE_MENU
			Menu_Click
			Return False
		Case Else
			Return True
	End Select
End Sub